ReflectionUtils (groovy 2.4.14 API)
Date: 2018-02-24

Package: org.codehaus.groovy.reflection

## [Java] Class ReflectionUtils

- org.codehaus.groovy.reflection.ReflectionUtils

- This class contains utility methods to determine which class called the current class to multiple levels of depth. Calls used to handle the groovy MOP are excluded from the level counting.

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `static Class` | `getCallingClass()` Get the immediate calling class, ignoring MOP frames.
    `` | `static Class` | `getCallingClass(int matchLevel)` Get the called that is matchLevel stack frames before the call, ignoring MOP frames.
    `` | `static Class` | `getCallingClass(int matchLevel, Collection<String> extraIgnoredPackages)` Get the called that is matchLevel stack frames before the call, ignoring MOP frames and desired exclude packages.
    `` | `static boolean` | `isCallingClassReflectionAvailable()` Determine whether or not the getCallingClass methods will return any sensible results.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Method Detail

    - #### public static Class getCallingClass()

      Get the immediate calling class, ignoring MOP frames.

      Returns:
        The Class of the caller

    - #### public static Class getCallingClass(int matchLevel)

      Get the called that is matchLevel stack frames before the call, ignoring MOP frames.

      Parameters:
        `matchLevel` - how may call stacks down to look. If it is less than 1 it is treated as though it was 1.
      Returns:
        The Class of the matched caller, or null if there aren't enough stackframes to satisfy matchLevel

    - #### public static Class getCallingClass(int matchLevel, Collection<String> extraIgnoredPackages)

      Get the called that is matchLevel stack frames before the call, ignoring MOP frames and desired exclude packages.

      Parameters:
        `matchLevel` - how may call stacks down to look. If it is less than 1 it is treated as though it was 1.
        `extraIgnoredPackages` - A collection of string names of packages to exclude in addition to the MOP packages when counting stack frames.
      Returns:
        The Class of the matched caller, or null if there aren't enough stackframes to satisfy matchLevel

    - #### public static boolean isCallingClassReflectionAvailable()

      Determine whether or not the getCallingClass methods will return any sensible results. On JVMs that are not Sun derived i.e. (gcj, Harmony) this will likely return false. When not available all getCallingClass methods will return null.

      Returns:
        true if getCallingClass can return anything but null, false if it will only return null.